#!/usr/bin/python

"""
We'll construct a tree that looks like this from a big dictionary:

A
  C
    E
    D
  B
F

"""

"These are the names"
names = {}
names['a'] = 'A'
names['b'] = 'B'
names['c'] = 'C'
names['d'] = 'D'
names['e'] = 'E'
names['f'] = 'F'

"We'll have the tree here, the values are looked up from names"
threaddict = {}

"These are equal, the C syntax is just clearer"
#threaddict = {'a': {'b': {}, 'c': {'d': {}, 'e': {} } }, 'f': {} }
threaddict = {
  'a': {
    'b': {}, 
    'c': {
      'd': {},
      'e': {},
    } 
  },
  'f': {}
}

print "threaddict:", threaddict
print ""

def printNodes(names, threaddict, level=0):
  for k, v in threaddict.items():
    if len(v) == 0:
      i = 0
      for i in range(0, level):
        print " ",
      print names[k]
    elif len(v) != 0:
      i = 0
      for i in range(0, level):
        print " ",
      print names[k]
      printNodes(names, v, level+1)
      
printNodes(names, threaddict)

